# RakNetTransport2 Class Reference
[RakNetTransport]

Use RakNetTransport if you need a secure connection between the client and the console server. More...

`#include <RakNetTransport2.h>`

Inheritance diagram for RakNetTransport2:

List of all members.

## Public Member Functions
bool | Start (unsigned short port, bool serverMode)
void | Stop (void)
| Stop the transport provider. You can clear memory and shutdown threads here.
void | Send (SystemAddress systemAddress, const char *data,...)
void | CloseConnection (SystemAddress systemAddress)
Packet * | Receive (void)
void | DeallocatePacket (Packet *packet)
SystemAddress | HasNewIncomingConnection (void)
SystemAddress | HasLostConnection (void)
virtual CommandParserInterface * | GetCommandParser (void)
virtual PluginReceiveResult | OnReceive (Packet *packet)
virtual void | OnClosedConnection (SystemAddress systemAddress, RakNetGUID rakNetGUID, PI2_LostConnectionReason lostConnectionReason)
virtual void | OnNewConnection (SystemAddress systemAddress, RakNetGUID rakNetGUID, bool isIncoming)

## Detailed Description

Use RakNetTransport if you need a secure connection between the client and the console server.

RakNetTransport automatically initializes security for the system. Use the project CommandConsoleClient to connect To the ConsoleServer if you use RakNetTransport

## Member Function Documentation

void RakNetTransport2::CloseConnection | ( | SystemAddress | systemAddress | ) | `[virtual]`

Disconnect systemAddress . The binary address and port defines the SystemAddress structure.

Parameters:

  `[in]` | systemAddress | The player/address to disconnect

Implements TransportInterface.

void RakNetTransport2::DeallocatePacket | ( | Packet * | packet | ) | `[virtual]`

Deallocate the Packet structure returned by Receive

Parameters:

  `[in]` | The | packet to deallocate

Implements TransportInterface.

virtual CommandParserInterface* RakNetTransport2::GetCommandParser | ( | void |  | ) | `[inline, virtual]`

Your transport provider can itself have command parsers if the transport layer has user-modifiable features For example, your transport layer may have a password which you want remote users to be able to set or you may want to allow remote users to turn on or off command echo

Returns:
  0 if you do not need a command parser - otherwise the desired derivation of CommandParserInterface

Implements TransportInterface.

SystemAddress RakNetTransport2::HasLostConnection | ( | void |  | ) | `[virtual]`

If a system loses the connection, you should queue that event and return the systemAddress/address of that player in this function.

Returns:
  The SystemAddress/address of the system

Implements TransportInterface.

SystemAddress RakNetTransport2::HasNewIncomingConnection | ( | void |  | ) | `[virtual]`

If a new system connects to you, you should queue that event and return the systemAddress/address of that player in this function.

Returns:
  The SystemAddress/address of the system

Implements TransportInterface.

virtual void RakNetTransport2::OnClosedConnection | ( | SystemAddress | systemAddress,
|  | RakNetGUID | rakNetGUID,
|  | PI2_LostConnectionReason | lostConnectionReason |
| ) |  |  | `[virtual]`

Called when a connection is dropped because the user called RakPeer::CloseConnection() for a particular system

Parameters:

  `[in]` | systemAddress | The system whose connection was closed
  `[in]` | rakNetGuid | The guid of the specified system
  `[in]` | lostConnectionReason | How the connection was closed: manually, connection lost, or notification of disconnection

Reimplemented from PluginInterface2.

virtual void RakNetTransport2::OnNewConnection | ( | SystemAddress | systemAddress,
|  | RakNetGUID | rakNetGUID,
|  | bool | isIncoming |
| ) |  |  | `[virtual]`

Called when we got a new connection

Parameters:

  `[in]` | systemAddress | Address of the new connection
  `[in]` | rakNetGuid | The guid of the specified system
  `[in]` | isIncoming | If true, this is ID_NEW_INCOMING_CONNECTION, or the equivalent

Reimplemented from PluginInterface2.

virtual PluginReceiveResult RakNetTransport2::OnReceive | ( | Packet * | packet | ) | `[virtual]`

OnReceive is called for every packet.

Parameters:

  `[in]` | packet | the packet that is being returned to the user

Returns:
  True to allow the game and other plugins to get this message, false to absorb it

Reimplemented from PluginInterface2.

Packet* RakNetTransport2::Receive | ( | void |  | ) | `[virtual]`

Return a string. The string should be allocated and written to Packet::data . The byte length should be written to Packet::length . The player/address should be written to Packet::systemAddress If your transport protocol adds special formatting to the data stream you should parse it out before returning it in the packet and thus only return a string in Packet::data

Returns:
  The packet structure containing the result of Receive, or 0 if no data is available

Implements TransportInterface.

void RakNetTransport2::Send | ( | SystemAddress | systemAddress,
|  | const char * | data,
|  |  | ... |
| ) |  |  | `[virtual]`

Send a null-terminated string to systemAddress If your transport method requires particular formatting of the outgoing data (e.g. you don't just send strings) you can do it here and parse it out in Receive().

Parameters:

  `[in]` | systemAddress | The player to send the string to
  `[in]` | data | format specifier - same as RAKNET_DEBUG_PRINTF
  `[in]` | ... | format specification arguments - same as RAKNET_DEBUG_PRINTF

Implements TransportInterface.

bool RakNetTransport2::Start | ( | unsigned short | port,
|  | bool | serverMode |
| ) |  |  | `[virtual]`

Start the transport provider on the indicated port.

Parameters:

  `[in]` | port | The port to start the transport provider on
  `[in]` | serverMode | If true, you should allow incoming connections (I don't actually use this anywhere)

Returns:
  Return true on success, false on failure.

Implements TransportInterface.

The documentation for this class was generated from the following file:

- d:/RakNet-3.x/Source/RakNetTransport2.h